// -*- C -*-



/*

 * The Javascript function in this module implement the policies defined

 * in "RLA0065 - JavaScript URL Mangling" - see that document for a

 * complete discussion of the logic here.

 */


function doAction(action, formname) {
	// If a form name is not supplied, will use the first form on the page.
	var objForm = formname!='' ? document.forms[formname] : document.forms[0];
	objForm.action=action;
	objForm.submit();
}




/*

 *  to turn on debugging from a calling HTML page, include

 *

 *   var script_js_debug=1;

 *

 * in a <SCRIPT> element.

 *

 */



// this is defined but unassigned - which makes the test agains

// "null" succeed.

var script_js_debug;



var bViewChange=false;

var bPatternChange=false;

var bRegexPatternChange=false;

var bPageChange = false;

var bSortChanged = false;

var bFilterChanged = false;

var bSelectChanged = false;

var bResetPressed = false;





/*

 * This function extends the basic JavaScript escape()

 * functionality by also encoding the '+' sign, which

 * will otherwise be mistaken for a space.

 */

function URLencode(str)

{

	ns = escape(str);

	os = "";



	for(i=ns.indexOf("+");-1!=i;i=ns.indexOf("+"))

	{

		os += ns.substr(0,i);

		os += "%2B";

		ns = ns.substr(i+1);

	}



	if((os.length !=0) && (ns.length != 0)) //add the rest of the original value.

		os += ns;



	if(0 == os.length)

	{

		os = ns;

	}



	debug("urlencode: "  + str + " --> " + os );

	return os;

}



function debug(str)

{

	if(null == script_js_debug )

	{

		return;

	}



	// else

	script_js_debug_window = window.open("","debug")

	script_js_debug_window.document.write(str);

	script_js_debug_window.document.write("<br>");

	return ;

}



//Returns an array containing old items (in current URL) check

function getQueryArgs()

{

	if(null == location.search)

	{

		return new Array();

	}

	args = location.search.split("?");

	if(args.length < 2)

	{

		return new Array();

	}

	s = args[1];

	args = s.split("&");

	return args;

}



/*

 *

 * Scans the query-string of the URL of the current page and returns an array

 * holding the values for the elements of the requested name. That is, if the

 * current query string is

 *

 *   ?arg1=val1&arg2=val2U&arg2=val3&arg4=val4

 *

 * then getFromUrl("arg1") would return ["val1"], and getFromUrl("arg2") would

 * return ["arg2","arg3"]

 *

 */

function getFromUrl(param)

{

	n = new Array();

	count = 0;

	args = getQueryArgs();

	for(i=0;i<args.length;i++)

	{

		nv = args[i].split("=");

		if(nv[0] != param)

		{

			continue;

		}

		n[count++] = nv[1];

	}

	return n;

}





//This will return ["sortParams",[sortParams]]. If no arguments passed return empty array.



function SortTableColumn(sortParams)

{

	if((null == sortParams) || ("" == sortParams) || (0 == arguments.length))

	{

		// no arguments actually passed...

		//return empty array

		return new Array("sortParams",new Array(null));

	}

	curvarg = getFromUrl("sortParams");

	newsortPramas = sortParams;

	//If both parameters are same change the order

	if(sortParams==curvarg)

	{

		if(newsortPramas.charAt(newsortPramas.length-1) == "a")

		{

			var s = newsortPramas.substring(0,newsortPramas.length-1);

			s = s + "d";

			newsortPramas = s;

		}

		else

		{

			if(newsortPramas.charAt(newsortPramas.length-1) == "d")

			{

				var s = newsortPramas.substring(0,newsortPramas.length-1);

				s = s + "a";

				newsortPramas = s;

			}

		}

	}

	return new Array("sortParams",new Array(newsortPramas));

}





/*

 * For a valid argument pnum, returns the array

 *

 *  ["page",[pnum]]

 *

 * Else returns

 *

 *  ["page",[1]]

 *

 */



function Page(pnum)

{

	bPageChange = true;

	if((null == pnum) || ("" == pnum))

	{

	pnum = "1";

	}



	// force conversion to string

	newpage = "" + pnum;

	debug("page: " + newpage);



	return new Array("page",new Array(newpage));

}



/*

 *

 * For a valid argument viewname, returns the array:

 *

 *  ["viewName",[viewname]]

 *

 * If the viewname arg is invalid, the ViewName param

 * from the current URL ("curview") is evaluated and, if

 * valid, the returned array is:

 *

 *  ["viewName",[curview]]

 *

 * If the curview is invalid, the returned array is:

 *

 *  ["viewName",["NoViewInCurrentURL"]]

 *

 * IN ADDITION this function sets a global flag (bViewChange)

 * iff the viewname arg is different from the curview (if any).

 *

 * This is to support gotoPage() implementing a precedence among

 * it's arguments.

 *

 */



function View(viewname)

{

	bViewChange = false;



	curvarg = getFromUrl("viewName");

	if((null == curvarg) || (0 == curvarg.length))

	{

		// current URL has no viewName

		debug("Current URL has no viewName");

		curview = "NoViewInCurrentURL";

	}

	else

	{

		curview = curvarg[0];

	}



	if((null == viewname) || ("" == viewname) || (0 == arguments.length))

	{

		// no arguments actually passed...

		debug("View() not passed any arguments");

		newview = curview;

	}

	else

	{

		newview = viewname;

	}



	debug("View(): " + curview + " -> " + viewname);

	if(curview != viewname)

	{

		bViewChange = true;

	}



	return new Array("viewName",new Array(newview));

}



function OldView(viewname)

{

	bViewChange = false;



	y = new Array();

	v = new Array();



	y = getFromUrl("ViewID");



	// If View() without any arguments current ViewID is returned

	if((viewname ==null) || (viewname == ""))

	{

		v[0] = y[0];

		return new Array("ViewID",v);

	}

	else

	{

		bViewChange = true;

		//Generates new ViewID

		if(y.length>0)

		{

			name = y[0];

			npos = name.indexOf("vn-");

			ViewType =name.substring(0,npos+3);

			w= new Array();

			v[0] = ViewType + viewname;

			w[0] = "ViewID";

			w[1] = v;

			return w;

		}

		else

		{



			v[0] = viewname;

			return new Array("ViewID", v);

		}

	}

}



/*

 *

 * Pattern

 *

 * Returns an array

 *

 *  ["pattern",[nv1,nv2,...]]

 *

 * Where nv1, etc., are URL encoded versions of strings of the form

 *

 *  Name1=Value1

 *

 * (The '=' is rendered as %3D)

 *

 * The set R of nv1,... is formed as the set

 *

 *   R = N v (O ^ ~(O ^ N))

 *

 * where

 *

 *    N is the set of name/value pairs from the function arguments

 *    O is the set of name/value pairs from the current URL

 *

 * See RLA0065 for a complete discussion

 *

 * IN ADDITION this function also sets a global variable bPatternChange

 * to indicate whether the passed-in nv pairs are different - in count

 * or content - from those found on the current page. This is to support

 * the gotoPage() function in applying logic to enforce precedence among

 * it's parameters.

 *

 */



function Pattern(varargs)

{

	bPatternChange = false;



	debug("Pattern() called");

	debug("  args: " + arguments);



	Index = 0;

	Incrementer =0;

	a = new Array();

	b = new Array();

	c = new Array();



	// Array p contains the all the encoded name/value pairs corrosponding

	// to patterns in current URL(Old Items).

	p = getFromUrl("pattern");



	// no arguments in varargs -> return an empty array

	if((null==varargs)|| (varargs =="") || (0 == arguments.length))

	{

		if(0 != p.length)

		{

			// this represents a change, so set the flag

			bPatternChange=true;

		}

		return new Array("pattern",new Array(null));

	}



	if(arguments.length != p.length)

	{

		debug("pattern: lengths differ");

		bPatternChange = true;

	}

	else

	{

		// copy arguments[] array because in IE it's not really

		// an Array() - it's just an Object and doesn't have a

		// sort() method.



		vargs = new Array();

		for(z=0;z<arguments.length;z++)

		{

			vargs[z] = arguments[z];

		}



		vargs.sort();

		p.sort();



		debug("pattern: p = " + p + " [" + p.length + "]");

		debug("pattern: v = " + vargs + " [" + vargs.length + "]");



		for(i=0;i<p.length;i++)

		{

			debug("pattern: cmp " + p[i] + " vs " + vargs[i]);

			if(p[i] != vargs[i])

			{

				debug("pattern: args differ: " + p[i] + " != " + vargs[i]);

				bPatternChange = true;

				break;

			}

		}

	}



	if(true == bPatternChange)

	{

		debug("pattern: change!");

	}

	else

	{

		debug("pattern: no change!");

	}



	// Detect and remove duplicates from varargs

	for(i=0;i<arguments.length;i++)

	{

		nv = arguments[i].split("%3D");

		if((nv.length != 2) || (nv[0] == "") || (nv[1] == ""))

		{

			// skip this argument

			continue;

		}



		found = false;



		// see if the same name occurs again later in the

		// list - if so, ignore the current one

		for(j=i+1;j<arguments.length;j++)

		{

			args = arguments[j].split("%3D");

			if(args[0] == nv[0])

			{

				found = true;

				debug("pattern: dup detected for " + args[0]);

				break;

			}

		}

		if(found == false)

		{

			b[Index++] = nv[0];

			b[Index++] = nv[1];

		}

	}



	// Array b now contains a cleaned list of the valid

	// name/value pairs from the varargs list. These are

	// no longer encoded.



	// This takes a particular name value pair from the p array

	// and takes the name part of it and compares it with the

	// name part of all name value pairs in the b array.

	//

	// If the name in interest is not found it is added to a

	// new array together with its value



	for(i=0;i<p.length;i++)

	{

		if((null == p[i]) || ("" == p[i]))

		{

			// invalid entry

			continue;

		}



		nv = p[i].split('%3D');

		if((2 != nv.length) || ("" == nv[0]) || ("" == nv[1]))

		{

			// invalid entry - skip it

			continue;

		}



		exists = false;



		// look at the name parts of the b array for a match

		for(m=0;m<Index;m= m+2)

		{

			if (nv[0] == b[m])

			{

				exists = true;

				debug("pattern: overriding " + nv[0] );

				break;

			}

		}



		// it goes into the "output" array only if it doesn't exist

		// in the b array.

		if(exists == false)

		{

			a[Incrementer++] = nv[0];

			a[Incrementer++] = nv[1];

		}

	}



	// Add in all the elements from b

	for(i=0;i<Index;i++)

	{

		a[Incrementer++] = b[i];

	}



	// Process the content in array a to generate the array which is the

	// return value from pattern function

	//

	// Resulting array will have two elements

	//

	//  - First element is the string "Pattern"

	//  - Second element is an array containing the encoded name/value pairs



	values = new Array();

	j = 0;

	for (i=0; i<Incrementer;i=i+2)

	{

		values[j] = (a[i] + "%3D" + a[i+1]);

		j = j+1;

	}

	if( values != "")

	{

		c[0] = "pattern";

		c[1] = values;

	}

	return c;

}





/*

 *

 * RegexPattern

 *

 * Accepts a (possibly-empty) list of arguments which are

 * name-value pairs:

 *

 *     [name1,value1][,...]

 *

 *

 * Unlike the Pattern() case, the arguments are not already

 * formed into URL-encoded pairs - this has to be done by

 * this function.

 *

 * Returns an array

 *

 *  ["regexpattern",[nv1,nv2,...]]

 *

 * Where nv1, etc., are URL encoded versions of strings of the form

 *

 *  name1=value1

 *

 * (The '=' is rendered as %3D)

 *

 * The set R of nv1,... is formed in the obvious way from the inputs.

 *

 * IN ADDITION this function also sets a global variable bRegexPatternChange

 * to indicate whether the passed-in nv pairs are different - in count

 * or content - from those found on the current page. This is to support

 * the gotoPage() function in applying logic to enforce precedence among

 * it's parameters.

 *

 */



function RegexPattern(arglist)

{

	bRegexPatternChange = false;



	// copy arguments[] array because in IE it's not really

	// an Array() - it's just an Object and doesn't have a

	// sort() method.

	//

	// At the same time, perform the URL encoding...



	varargs = new Array();

	for(z=0;z<arguments.length/2;z++)

	{

		s = arguments[2*z] + "=" + arguments[2*z+1];

		varargs[z] = URLencode(s);

	}



	debug("RegexPattern() called");

	debug("  args: " + varargs);



	Index = 0;

	Incrementer =0;

	a = new Array();

	b = new Array();

	c = new Array();



	// Array p contains the all the encoded name/value pairs corrosponding

	// to patterns in current URL(Old Items).

	p = getFromUrl("regexpattern");



	// no arguments in varargs -> return an empty array

	if((null==arglist)|| (arglist =="") || (0 == varargs.length))

	{

		if(0 != p.length)

		{

			// this represents a change, so set the flag

			bRegexPatternChange=true;

		}

		return new Array("regexpattern",new Array(null));

	}



	if(varargs.length != p.length)

	{

		debug("regexpattern: lengths differ");

		bRegexPatternChange = true;

	}

	else

	{

		varargs.sort();

		p.sort();



		debug("regexpattern: p = " + p + " [" + p.length + "]");

		debug("regexpattern: v = " + varargs + " [" + varargs.length + "]");



		for(i=0;i<p.length;i++)

		{

			debug("regexpattern: cmp " + p[i] + " vs " + varargs[i]);

			if(p[i] != varargs[i])

			{

				debug("regexpattern: args differ: " + p[i] + " != " + varargs[i]);

				bRegexPatternChange = true;

				break;

			}

		}

	}



	if(true == bRegexPatternChange)

	{

		debug("regexpattern: change!");

	}

	else

	{

		debug("regexpattern: no change!");

	}



	// Detect and remove duplicates from varargs

	for(i=0;i<varargs.length;i++)

	{

		nv = varargs[i].split("%3D");

		if((nv.length != 2) || (nv[0] == "") || (nv[1] == ""))

		{

			// skip this argument

			continue;

		}



		found = false;



		// see if the same name occurs again later in the

		// list - if so, ignore the current one

		for(j=i+1;j<varargs.length;j++)

		{

			args = varargs[j].split("%3D");

			if(args[0] == nv[0])

			{

				found = true;

				debug("pattern: dup detected for " + args[0]);

				break;

			}

		}

		if(found == false)

		{

			b[Index++] = nv[0];

			b[Index++] = nv[1];

		}

	}



	// Array b now contains a cleaned list of the valid

	// name/value pairs from the varargs list. These are

	// no longer encoded.



	// This takes a particular name value pair from the p array

	// and takes the name part of it and compares it with the

	// name part of all name value pairs in the b array.

	//

	// If the name in interest is not found it is added to a

	// new array together with its value



	for(i=0;i<p.length;i++)

	{

		if((null == p[i]) || ("" == p[i]))

		{

			// invalid entry

			continue;

		}



		nv = p[i].split('%3D');

		if((2 != nv.length) || ("" == nv[0]) || ("" == nv[1]))

		{

			// invalid entry - skip it

			continue;

		}



		exists = false;



		// look at the name parts of the b array for a match

		for(m=0;m<Index;m= m+2)

		{

			if (nv[0] == b[m])

			{

				exists = true;

				debug("regexpattern: overriding " + nv[0] );

				break;

			}

		}



		// it goes into the "output" array only if it doesn't exist

		// in the b array.

		if(exists == false)

		{

			a[Incrementer++] = nv[0];

			a[Incrementer++] = nv[1];

		}

	}



	// Add in all the elements from b

	for(i=0;i<Index;i++)

	{

		a[Incrementer++] = b[i];

	}



	// Process the content in array a to generate the array which is the

	// return value from pattern function

	//

	// Resulting array will have two elements

	//

	//  - First element is the string "regexpattern"

	//  - Second element is an array containing the encoded name/value pairs



	values = new Array();

	j = 0;

	for (i=0; i<Incrementer;i=i+2)

	{

		values[j] = (a[i] + "%3D" + a[i+1]);

		j = j+1;

	}

	if( values != "")

	{

		c[0] = "regexpattern";

		c[1] = values;

	}

	return c;

}



/*

 *

 * PrepareSortParams

 *

 * PrepareSortParams() returns an array which contains the SortElements which

 * are going to be in the new URL

 *

 * It accepts a variable argument list, it is the same argument list which gotopage() function

 * accepts and the members of which are arrays created in the other "element" functions including

 * SortElement() function

 *

 * Each of these arrays has the same form -

 *

 *  [<name>,[<value>[...]]]

 *

 * This function discard all the arrays except which is return by SortElement function and creates

 * the array which holds SortElements

 *

 * The arrays return by  PrepareSortParams()has the form

 *

 *  [<name>,[<value>[...]]

 * eg. [<SortElement>,[<calltime%5E0123%5Eto>]

 *

 */





 function PrepareSortParams(ParamArrays)

 {

	newsortArr = new Array();

	allsortvals = new Array();

	sortvals = new Array();

	svals = new Array();

	newSortArray = new Array();

	tempSortArr = new Array();

	c =0;

	inc = 0;

	bIncluded =false;

	bTobeAdded = true;

//Since there is no scinario that could be justified as Sort is not changed when clicking a sort link(even

//clicking the same link) bSortChanged is always set to true. This is used to set the page to 1 when clicking

// a soting link

	bSortChanged = true;



 // ParamArrays contains arrays created in the other "element" functions e.g. Page(),

 // SortElement(), Pattern(), etc..

	for(i =0; i<ParamArrays.length; i++)

	{

 //honers only arrays created by SortElement() function

 //Removes Duplicates

 //i.e. if the gotopage call is like gotopage(....,SortElement(spec1%5EUID1%5Eto),SortElement(spec1%5EUID1%5Eto),...)

 //or like (....,SortElement(spec1%5EUID1%5Eto),SortElement(spec2%5EUID1%5Eto),...)then only the first call to SortElement

 //function with in gotopage function will be honered. Note that in all cases same UID is used as a param

 //to SortElement function

		if(ParamArrays[i][0] == "SortElement")

		{

			bSortCalled = true;

			svals = ParamArrays[i][1];

			if(svals[0] != null)

			{

					nv = svals[0].split("%5E");

					//if(sortvals !="")



					for(n=0; n<sortvals.length; n++)

						{

							if( nv[1] == sortvals[n])

							{

							bTobeAdded = false;

							}

						}

					if (bTobeAdded == true)

						{

							for (m =0; m<nv.length;m++)

							{



								sortvals[inc++] = nv[m];

							}

						}

			}

		}



	}



//Gets the SortlElements in current URL

//Keeps the current URL as a globale variable and do changes on it if and only if

//the current URL has a sortelement which has a UID as same as what is returned by the

//SortElement function else add what is returned by the SortElement as a new element

//When ever a user clicks the same link again then relative direction will be changed





CurrentSortArray = getFromUrl("SortElement");



//If all SortElement function calls have returned null and no SortElements in current URL

// then PrepareSortPrams function will return null too.

	if((sortvals.length == 0) && (CurrentSortArray.length == 0) )

	{

		return new Array("SortElement",new Array(null));

	}



// If view has changed then discard all SortElements in current URL and creats an array

// with only the values retuned by SortElement functions

	if (bViewChange)

	{

		if(sortvals.length != 0)

		{

			e=0;

			for(j=0; j<sortvals.length ; j =j+3)

			{

				tempSortArr[e] =sortvals[j] + "%5E" + sortvals[j+1] + "%5E" + sortvals[j+2];

				e++

			}

			newsortArr[0] = "SortElement";

			newsortArr[1] =  tempSortArr;



			return newsortArr;

		}

		else

		{

			return new Array("SortElement",new Array(null));

		}





	}



	// If ResetUrl called (bResetPressed==true) and the

	// URL spec matches exactly (name and UID) the one in the

	// SortElement() argument list, we set the direction to be

	// the opposite of the URL value.  This must be done in order to

	// allow the sort direction to be toggled when ResetUrl is used.



	if ( bResetPressed )

	{

		for (m =0; m<sortvals.length;m=m+3)

		{

			for(j = 0; j<CurrentSortArray.length ; j++)

			{

				urlsortargs = CurrentSortArray[j].split("%5E");



				if (3 != urlsortargs.length)

				{

					continue;

				}



				if ( urlsortargs[0] == sortvals[m] && urlsortargs[1] == sortvals[m+1] )

				{

					// Toggle the to/fro in the new spec based on the old one

					sortvals[m+2] = (urlsortargs[2] == "to") ? "fro" : "to";



					// We don't need to look any more at the URL once we find a match,

					// so break out of the loop going thru the URL.

					break;

				}

			}



			tempSortArr[c++] = sortvals[m] + "%5E" + sortvals[m+1] + "%5E" + sortvals[m+2];

		}



		newsortArr[0] = "SortElement";

		newsortArr[1] =  tempSortArr;



		return newsortArr;

	}



	for (m =0; m<sortvals.length;m=m+3)

		{

		 bIncluded = false;

		 for(j = 0; j<CurrentSortArray.length ; j++)

			{

				sortargs = CurrentSortArray[j].split("%5E");

				if((3 != sortargs.length))

				{

					continue;

				}



				if (sortargs[1] == sortvals[m+1])

				{

					bIncluded = true;

					if (sortargs[0] == sortvals[m])

					{

						if (sortargs[2] == "to")

						{



							CurrentSortArray[j] = (sortvals[m] + "%5E" + sortvals[m+1] + "%5E" + "fro");

						}

						else

						{



							CurrentSortArray[j] = (sortvals[m] + "%5E" + sortvals[m+1] + "%5E" + "to");

						}

					}

					else

					{





						CurrentSortArray[j] = (sortvals[m] + "%5E" + sortvals[m+1] + "%5E" + sortvals[m+2]);

					}

				}

				else

				{

						continue;



				}





			}//End For



			if (bIncluded == false)

				{



						newSortArray[c++] = sortvals[m] + "%5E" + sortvals[m+1] + "%5E" + sortvals[m+2];



				}







		}



		for(j = 0; j<CurrentSortArray.length ; j++)

		{

			tempSortArr[j] =CurrentSortArray[j];

		}



		for(i = j; i<(j+newSortArray.length) ; i++)

		{

			tempSortArr[i] =newSortArray[i-j];

		}





					newsortArr[0] = "SortElement";

					newsortArr[1] =  tempSortArr;



			return newsortArr;





 }







/*

 *

 * SortElement

 *

 * SortElement() accepts three arguments spec name , UniqueID and relative direction

 * It Url encode these three params with %5E  and returns an array as an output which has two

 * elements . The first element is the text "SortElement" and second element is another array

 * which hold the encoded string.

 *

 *  eg. [<SortElement>,[<calltime%5E0123%5Eto>]

 *

 * In case if one of the params it accept is null this will return array with null value

 *

 */







 function SortElement(arglist)

 {



	ElementString ="";

	newsortvals = new Array();

	ElemntRetArr = new Array();

	if(arguments.length != 3 ||arguments[0] =="" || arguments[1]=="" ||arguments[2]=="")

	{

		return new Array("SortElement",new Array(null));

	}

	else

	{

	for(z =0; z<arguments.length;z++)

		{

			if (ElementString.length>0)

				{

					ElementString = ElementString + "^" + arguments[z];

				}

			else

				{

					ElementString = arguments[z];

				}

		}



		ElementString = URLencode(ElementString);

		ElemntRetArr[0] = ElementString;



				if (ElementString != "")

				{

					newsortvals[0] = "SortElement";

					newsortvals[1] =  ElemntRetArr;

				}

	}

				return newsortvals;

 }











 /*

 *

 * PrepareFilterParams

 *

 * PrepareFilterParams() returns an array which contains the Filter elements which

 * are going to be in the new URL

 *

 * It accepts a variable argument list, it is the same argument list which gotopage() function

 * accepts and the members of which are arrays created in the other "element" functions including

 * Filter() function

 *

 * Each of these arrays has the same form -

 *

 *  [<name>,[<value>[...]]]

 *

 * This function discard all the arrays except which is return by Filter function and creates

 * the array which holds Filter elements

 *

 * The arrays return by  PrepareSortParams()has the form

 *

 *  [<name>,[<value>[...]]

 * eg. [<Filter>,[<calltime%5E0123>]

 *

 */





 function PrepareFilterParams(ParamArrays)

 {

	newfilterArr = new Array();

	allfiltervals = new Array();

	filtervals = new Array();

	svals = new Array();

	newFilterArray = new Array();

	tempFilterArr = new Array();

	c =0;

	inc = 0;

	bFIncluded =false;

	bFTobeAdded = true;



//I assume clicking a link with Filter will always mean changing Filter(even clicking the same link)

// bFilterChanged is always set to true. This is used to set the page to 1 when clicking

// a link with filter



	bFilterChanged = true;



 // ParamArrays contains arrays created in the other "element" functions e.g. Page(),

 // SortElement(), Pattern(), etc..

	for(i =0; i<ParamArrays.length; i++)

	{

 //honers only arrays created by Filter() function

 //Removes Duplicates

 //i.e. if the gotopage call is like gotopage(....,Filter(spec1%5EUID1),Filter(spec1%5EUID1),...)

 //or like (....,Filter(spec1%5EUID1),Filter(spec2%5EUID1),...)then only the first call to Filter

 //function with in gotopage function will be honered. Note that in all cases same UID is used as a param

 //to Filter function

		if(ParamArrays[i][0] == "Filter")

		{

			svals = ParamArrays[i][1];

			if(svals[0] != null)

			{

					nv = svals[0].split("%5E");

					if(filtervals !="")



					for(n=0; n<filtervals.length; n++)

						{

							if( nv[1] == filtervals[n])

							{

							bFTobeAdded = false;

							}

						}

					if (bFTobeAdded == true)

						{

							for (m =0; m<nv.length;m++)

							{



								filtervals[inc++] = nv[m];

							}

						}

			}

		}



	}





	//Gets the FilterElements in current URL

	//Keeps the current URL as a globale variable and do changes on it if and only if

	//the current URL has a Filter which has a UID as same as what is returned by the

	//Filter function else add what is returned by the Filter function as a new element





	CurrentFilterArray = getFromUrl("Filter");



//If all Filter function calls have returned null and  there is no Filter items in

//current URL then PrepareSortPrams function will return null too.

	if((filtervals.length == 0) && (CurrentFilterArray.length == 0))

	{

		return new Array("Filter",new Array(null));

	}



// If view has changed then discard all Filter elements in current URL and creats an array

// with only the values retuned by Filter functions

	if (bViewChange || bResetPressed)

	{

		if(filtervals.length != 0)

		{

			e=0;

			for(j=0; j<filtervals.length ; j =j+2)

			{

				tempFilterArr[e] =filtervals[j] + "%5E" + filtervals[j+1];

				e++

			}

			newfilterArr[0] = "Filter";

			newfilterArr[1] =  tempFilterArr;



			return newfilterArr;

		}



	 else

		{

			return new Array("Filter",new Array(null));

		}



	}







	for (m =0; m<filtervals.length;m=m+2)

		{

		 bFIncluded = false;

		 for(j = 0; j<CurrentFilterArray.length ; j++)

			{

				filterarg = CurrentFilterArray[j].split("%5E");

				if((2 != filterarg.length))

				{

					continue;

				}



				if (filterarg[1] == filtervals[m+1])

				{

					bFIncluded = true;

					if (filterarg[0] == filtervals[m])

					{

						continue;

					}

					else

					{





						CurrentFilterArray[j] = (filtervals[m] + "%5E" + filtervals[m+1]);

					}

				}

				else

				{

						continue;



				}





			}//End For



			if (bFIncluded == false)

				{



						newFilterArray[c++] = (filtervals[m] + "%5E" + filtervals[m+1]);



				}







		}



		for(j = 0; j<CurrentFilterArray.length ; j++)

		{

			tempFilterArr[j] =CurrentFilterArray[j];

		}



		for(i = j; i<(j+newFilterArray.length) ; i++)

		{

			tempFilterArr[i] =newFilterArray[i-j];

		}





					newfilterArr[0] = "Filter";

					newfilterArr[1] =  tempFilterArr;



			return newfilterArr;





 }







 /*

 *

 * Filter

 *

 * Filter() accepts two arguments Filter Name, UniqueID

 * It Url encode these two params with %5E  and returns an array as an output which has two

 * elements . The first element is the text "Filter" and second element is another array

 * which hold the encoded string.

 *

 *  eg. [<Filter>,[<calltime%5E0123>]

 *

 * In case if one of the params it accept is null this will return array with null value

 *

 */





 function Filter(arglist)

 {







	ElementString ="";

	newfiltervals = new Array();

	ElemntRetArr = new Array();

	if(arguments.length != 2 ||arguments[0] =="" || arguments[1]=="")

	{

		return new Array("Filter",new Array(null));

	}

	else

	{

	for(z =0; z<arguments.length;z++)

		{

			if (ElementString.length>0)

				{

					ElementString = ElementString + "^" + arguments[z];

				}

			else

				{

					ElementString = arguments[z];

				}

		}



		ElementString = URLencode(ElementString);

		ElemntRetArr[0] = ElementString;



				if (ElementString != "")

				{

					newfiltervals[0] = "Filter";

					newfiltervals[1] =  ElemntRetArr;

				}

	}

				return newfiltervals;



 }









/*

 *

 * PrepareSelectParams

 *

 * PrepareSelectParams() returns an array which contains the Select elements which

 * are going to be in the new URL

 *

 * It accepts a variable argument list, it is the same argument list which gotopage() function

 * accepts and the members of which are arrays created in the other "element" functions including

 * Select() function

 *

 * Each of these arrays has the same form -

 *

 *  [<name>,[<value>[...]]]

 *

 * This function discard all the arrays except which is return by Select function and creates

 * the array which holds Select elements

 *

 * The arrays return by  PrepareSortParams()has the form

 *

 *  [<name>,[<value>[...]]

 * eg. [<Select>,[<status%5E0123%5E20>]

 *

 */





 function PrepareSelectParams(ParamArrays)

 {

	newselectArr = new Array();

	allselectvals = new Array();

	selectvals = new Array();

	svals = new Array();

	newSelectArray = new Array();

	tempselectArr = new Array();

	c =0;

	inc = 0;

	bSIncluded =false;

	bSTobeAdded = true;



//I assume clicking a link with Select will always mean changing Select(even clicking the same link)

// bFilterChanged is always set to true. This is used to set the page to 1 when clicking

// a link with Select



	bSelectChanged = true;



 // ParamArrays contains arrays created in the other "element" functions e.g. Page(),

 // SortElement(), Pattern(), etc..

	for(i =0; i<ParamArrays.length; i++)

	{

 //honers only arrays created by Select() function

 //Removes Duplicates

 //i.e. if the gotopage call is like gotopage(....,Select(spec1%5EUID1),Select(spec1%5EUID1),...)

 //or like (....,Select(spec1%5EUID1),Select(spec2%5EUID1),...)then only the first call to Select

 //function with in gotopage function will be honered. Note that in all cases same UID is used as a param

 //to Select function

		if(ParamArrays[i][0] == "Select")

		{

			svals = ParamArrays[i][1];

			if(svals[0] != null)

			{

					nv = svals[0].split("%5E");

					if(selectvals !="")



					for(n=0; n<selectvals.length; n++)

						{

							if( nv[1] == selectvals[n])

							{

							bSTobeAdded = false;

							}

						}

					if (bSTobeAdded == true)

						{

							for (m =0; m<nv.length;m++)

							{



								selectvals[inc++] = nv[m];

							}

						}

			}

		}



	}





	//Gets the SelectElements in current URL

	//Keeps the current URL as a globale variable and do changes on it if and only if

	//the current URL has a Select which has a UID as same as what is returned by the

	//Select function else add what is returned by the Select function as a new element





	CurrentSelectArray = getFromUrl("Select");



//If all Select function calls have returned null and  there is no Select items in

//current URL then PrepareSelectPrams function will return null too.

	if((selectvals.length == 0) && (CurrentSelectArray.length == 0))

	{

		return new Array("Select",new Array(null));

	}



// If view has changed then discard all Select elements in current URL and creats an array

// with only the values retuned by Select functions

	if (bViewChange || bResetPressed)

	{

		if(selectvals.length != 0)

		{

			e=0;

			for(j=0; j<selectvals.length ; j =j+3)

			{

				tempselectArr[e] =selectvals[j] + "%5E" + selectvals[j+1]+ "%5E" + selectvals[j+2];

				e++

			}

			newselectArr[0] = "Select";

			newselectArr[1] =  tempselectArr;



			return newselectArr;

		}



	 else

		{

			return new Array("Select",new Array(null));

		}



	}







	for (m =0; m<selectvals.length;m=m+3)

		{

		 bSIncluded = false;

		 for(j = 0; j<CurrentSelectArray.length ; j++)

			{

				Selectarg = CurrentSelectArray[j].split("%5E");

				if((3 != Selectarg.length))

				{

					continue;

				}



				if (Selectarg[1] == selectvals[m+1])

				{

					bSIncluded = true;

					if (Selectarg[0] == selectvals[m])

					{

						if((Selectarg[2]=="") && (selectvals[m+2]==""))

						{

							continue;

						}

						else

						{

							CurrentSelectArray[j] = (selectvals[m] + "%5E" + selectvals[m+1]+ "%5E" + selectvals[m+2]);

						}



					}

					else

					{





						CurrentSelectArray[j] = (selectvals[m] + "%5E" + selectvals[m+1]+ "%5E" + selectvals[m+2]);

					}

				}

				else

				{

						continue;



				}





			}//End For



			if (bSIncluded == false)

				{



						newSelectArray[c++] = (selectvals[m] + "%5E" + selectvals[m+1]+ "%5E" + selectvals[m+2]);



				}







		}



		for(j = 0; j<CurrentSelectArray.length ; j++)

		{

			tempselectArr[j] =CurrentSelectArray[j];

		}



		for(i = j; i<(j+newSelectArray.length) ; i++)

		{

			tempselectArr[i] =newSelectArray[i-j];

		}





					newselectArr[0] = "Select";

					newselectArr[1] =  tempselectArr;



			return newselectArr;





 }











/*

 *

 * Select

 *

 * Select() accepts three arguments select Name, UniqueID , count

 * It Url encode these three params with %5E  and returns an array as an output which has two

 * elements . The first element is the text "Select" and second element is another array

 * which hold the encoded string.

 *

 *  eg. [<Select>,[<Status%5E01343%5E10>]

 *

 * In case if one of the params it accept is null this will return array with null value

 *

 */





 function Select(arglist)

 {



	ElementString ="";

	newselectvals = new Array();

	ElemntRetArr = new Array();

	LengthArr = new Array();







	if((arguments.length == 3) || (arguments.length == 2))

	{

		for(i=0;i<arguments.length;i++)

			{

				if(arguments[i] == "")

				{

					return new Array("Select",new Array(null));

				}

				LengthArr[i] = arguments[i];

			}





		if(arguments.length == 2)

		{

			LengthArr[i] ="";

		}

	}

	else

	{

		return new Array("Select",new Array(null));

	}





	for(z =0; z<LengthArr.length;z++)

		{

			if (ElementString.length>0)

				{

					ElementString = ElementString + "^" + LengthArr[z];

				}

			else

				{

					ElementString = LengthArr[z];

				}

		}



		ElementString = URLencode(ElementString);

		ElemntRetArr[0] = ElementString;



				if (ElementString != "")

				{

					newselectvals[0] = "Select";

					newselectvals[1] =  ElemntRetArr;

				}



				return newselectvals;



 }



/*

  *

  *

  * ResetAll()

  *

  * Returns an array containing with two elements, first element is text "Reset" and second element is an array

  * with null value and pattern elements

  *

  * This function also set a global boolean variable(bResetPressed) to true

  *

  *

  */



  function ResetUrl()

  {



	bResetPressed = true;

	return new Array("Reset",new Array(null)) ;



  }









/*

 *

 * gotoPage() calculates a "target" URL based on the URL of the

 * current page and the arguments passed to it.

 *

 * It accepts a variable argument list, the members of which are

 * the arrays created in the other "element" functions e.g. Page(),

 * Sort(), Pattern(), etc..

 *

 * Each of these arrays has the same form -

 *

 *  [<name>,[<value>[...]]]

 *

 * e.g. ["page",["1"]]

 *

 * This is a compact way of encoding  (name,value) pairs that will be

 * put into the "new" URL.

 *

 * gotoPage() constructs a new URL by merging the query-string from the URL

 * of the current page (if any) with the passed values, with the passed

 * values overriding the "current" args. So, if the query-string for the

 * current URL includes:

 *

 *  ...&page=3&...

 *

 * and the array ["page",["4"]] is passed in, the caclculated URL will

 * include ...&page=4&...

 *

 * There are several dependencies between arguments that gotoPage() has

 * to resolve.

 *

 * 1) If the "new" page has a different View or different list of Patterns

 *    or RegexPatterns, any "page" parameter in the current URL will be

 *    discarded. If there is an explicit page value set via the parameters

 *    it will be honored, otherwise there will be NO page value in the URL,

 *    which is the same as "page=1".

 *

 * 2) If the "new" page has a different View, then Patterns, RegexPatterns,

 *    and sortParams from the "current" URL will be discarded.

 *

 * 3) If the "new" page has a different View, Pattern, RegexPattern, or Page,

 *    then the sortParams from the "current" URL will be discarded.

 *

 */



function gotoPage(paramlist)

{

	x = new Array;

	countup = 0;



	debug("gotoPage() called");



	// Finds old items in current URL which are only found in it

	// Array X holds the result items that will form the new URL



	args = getQueryArgs();









	//filterargs contains all the sort elements that is going to be apear in new URL

	  filterargs = PrepareFilterParams(arguments);



	  //sortargs contains all the sort elements that is going to be apear in new URL

	  sortargs = PrepareSortParams(arguments);



	  //selectargs contains all the select elements that is going to be apear in new URL

	  selectargs = PrepareSelectParams(arguments);







	for (i=0;i<args.length;i++)

	{



		nv =args[i].split("=");

		if((null == nv) || (2 != nv.length))

		{

			// invalid querystring arg - skip it

			debug("invalid querystring arg: " + args[i] + " - skipping");

			continue;

		}



		// handle special Page override as needed

		if(("page" == nv[0]) && (bViewChange || bPatternChange || bRegexPatternChange ||

								 bSortChanged || bFilterChanged || bSelectChanged || bResetPressed))

		{

			// suppress use of "current page"

			debug("gotoPage: page 1 override");

			continue;

		}



		// handle Pattern override as needed

		if(("pattern" == nv[0]) && (bViewChange))

		{

			// suppress use of "current pattern"

			debug("gotoPage: discarding current pattern because view has changed");

			continue;

	        }
	
	        if(("addressbook" == nv[0]))

		 {

			// suppress use of "current pattern"

			debug("gotoPage: discarding address book toggle");

			continue;

	          }



		// handle RegexPattern override as needed

		if(("regexpattern" == nv[0]) && (bViewChange))

		{

			// suppress use of "current regexpattern"

			debug("gotoPage: discarding current regexpattern because view has changed");

			continue;

		}



		// handle Sort override as needed

		if(("sortParams"==nv[0]) && (bViewChange || bPatternChange || bRegexPatternChange ||bPageChange))

		{

			// suppress use of current sort parameters

			debug("gotoPage: discarding current sort parameters because something has changed");

			continue;

		}





		found = false;



		for(j=0;j<arguments.length;j++)

		{

			debug("checking: " + nv[0] + " vs. " + arguments[j][0]);

			if (nv[0] == arguments[j][0])

			{



				found =true;

				break;

			}

		}



		if(found == false)

		{

			if((nv[0] == "SortElement") || (nv[0] == "Filter") || (nv[0] == "Select"))

				{

					break;

				}



			x[countup++] = nv[0];

			x[countup++] = nv[1];

		}

	}







	// Array X now holds the items from the current URL

	// Now Populate the array X with the new items from value arrays



	for (k=0; k<arguments.length;k++)

	{



			debug("gotoPage arg " + k + ": " + arguments[k]);



			nname = arguments[k][0];

			nvals = arguments[k][1];

			if((nname == "SortElement") || (nname == "Filter") || (nname == "Select"))

				{

					continue;

				}

			if(nvals[0] != null)

			{

				for (m =0; m<nvals.length;m++)

				{



					x[countup++] = nname;

					x[countup++] = nvals[m];

				}

			}



	}



	//Add SortElements one by one to the array which is used to create the new url

	if(sortargs[1][0] != null)

	{

		for(z=0;z<sortargs[1].length;z++)

		{

			x[countup++] = "SortElement";

			x[countup++] =	sortargs[1][z];

		}



	}



	//Add Filter elements one by one to the array which is used to create the new url

	if(filterargs[1][0] != null)

	{

		for(z=0;z<filterargs[1].length;z++)

		{

			x[countup++] = "Filter";

			x[countup++] =	filterargs[1][z];

		}



	}





	//Add Select elements one by one to the array which is used to create the new url

	if(selectargs[1][0] != null)

	{

		for(z=0;z<selectargs[1].length;z++)

		{

			x[countup++] = "Select";

			x[countup++] =	selectargs[1][z];

		}



	}





	// reset defaults

	bViewChange = false;

	bPatternChange = false;

	bRegexPatternChange = false;

	bPageChange = false;

	bSortChanged = false;

	bFilterChanged = false;

	bSelectChanged = false;

	bResetPressed =false;



	// Process the array X and generate new URL

	query = "";

	for(i=0;i<x.length/2;i++)

	{

		if(query.length>0)

		{

			query = query + "&";

		}

		query = query + x[2*i] + "=" + x[2*i+1];

	}



	if(query != "")

	{

		url = "displayView.do?" + query ;

	}

	else

	{

		url = "displayView.do";

	}



	debug("new url: " + url);

	return url;

}





// This function add the attribute subIdx=<subIdx> to the url

function gotoSubIdxPage(paramlist, subIdx)

{

	// let the gotoPage does its work

	var url = gotoPage(paramlist);



	// format the subIdx

	subIdx = formatsubIndex(subIdx);

	

	// add the subIdx to url

	url = url + "&subIdx=" + subIdx;



	return url;

}

// This function add the attribute subIdx=<subIdx> to the url

function gotoSubIndexPage(paramlist, subIdx)

{

	// let the gotoPage does its work

	var url = gotoPage(paramlist);

	// add the subIdx to url

	url = url + "&subIdx=" + subIdx;



	return url;

}




function gotoUsageDetail(paramlist)

{

	x = new Array;

	countup = 0;



	debug("gotoPage() called");



	// Finds old items in current URL which are only found in it

	// Array X holds the result items that will form the new URL



	args = getQueryArgs();









	//filterargs contains all the sort elements that is going to be apear in new URL

	  filterargs = PrepareFilterParams(arguments);



	  //sortargs contains all the sort elements that is going to be apear in new URL

	  sortargs = PrepareSortParams(arguments);



	  //selectargs contains all the select elements that is going to be apear in new URL

	  selectargs = PrepareSelectParams(arguments);







	for (i=0;i<args.length;i++)

	{



		nv =args[i].split("=");

		if((null == nv) || (2 != nv.length))

		{

			// invalid querystring arg - skip it

			debug("invalid querystring arg: " + args[i] + " - skipping");

			continue;

		}



		// handle special Page override as needed

		if(("page" == nv[0]) && (bViewChange || bPatternChange || bRegexPatternChange ||

								 bSortChanged || bFilterChanged || bSelectChanged || bResetPressed))

		{

			// suppress use of "current page"

			debug("gotoPage: page 1 override");

			continue;

		}



		// handle Pattern override as needed

		if(("pattern" == nv[0]) && (bViewChange))

		{

			// suppress use of "current pattern"

			debug("gotoPage: discarding current pattern because view has changed");

			continue;

	       }
	
	
		if(("addressbook" == nv[0]))

		{

			// suppress use of "current pattern"

			debug("gotoPage: discarding current pattern because view has changed");

			continue;

	       }
	
	
	      



		// handle RegexPattern override as needed

		if(("regexpattern" == nv[0]) && (bViewChange))

		{

			// suppress use of "current regexpattern"

			debug("gotoPage: discarding current regexpattern because view has changed");

			continue;

		}



		// handle Sort override as needed

		if(("sortParams"==nv[0]) && (bViewChange || bPatternChange || bRegexPatternChange ||bPageChange))

		{

			// suppress use of current sort parameters

			debug("gotoPage: discarding current sort parameters because something has changed");

			continue;

		}





		found = false;



		for(j=0;j<arguments.length;j++)

		{

			debug("checking: " + nv[0] + " vs. " + arguments[j][0]);

			if (nv[0] == arguments[j][0])

			{



				found =true;

				break;

			}

		}



		if(found == false)

		{

			if((nv[0] == "SortElement") || (nv[0] == "Filter") || (nv[0] == "Select"))

				{

					break;

				}



			x[countup++] = nv[0];

			x[countup++] = nv[1];

		}

	}







	// Array X now holds the items from the current URL

	// Now Populate the array X with the new items from value arrays



	for (k=0; k<arguments.length;k++)

	{



			debug("gotoPage arg " + k + ": " + arguments[k]);



			nname = arguments[k][0];

			nvals = arguments[k][1];

			if((nname == "SortElement") || (nname == "Filter") || (nname == "Select"))

				{

					continue;

				}

			if(nvals[0] != null)

			{

				for (m =0; m<nvals.length;m++)

				{



					x[countup++] = nname;

					x[countup++] = nvals[m];

				}

			}



	}



	//Add SortElements one by one to the array which is used to create the new url

	if(sortargs[1][0] != null)

	{

		for(z=0;z<sortargs[1].length;z++)

		{

			x[countup++] = "SortElement";

			x[countup++] =	sortargs[1][z];

		}



	}



	//Add Filter elements one by one to the array which is used to create the new url

	if(filterargs[1][0] != null)

	{

		for(z=0;z<filterargs[1].length;z++)

		{

			x[countup++] = "Filter";

			x[countup++] =	filterargs[1][z];

		}



	}





	//Add Select elements one by one to the array which is used to create the new url

	if(selectargs[1][0] != null)

	{

		for(z=0;z<selectargs[1].length;z++)

		{

			x[countup++] = "Select";

			x[countup++] =	selectargs[1][z];

		}



	}





	// reset defaults

	bViewChange = false;

	bPatternChange = false;

	bRegexPatternChange = false;

	bPageChange = false;

	bSortChanged = false;

	bFilterChanged = false;

	bSelectChanged = false;

	bResetPressed =false;



	// Process the array X and generate new URL

	query = "";

	for(i=0;i<x.length/2;i++)

	{

		if(query.length>0)

		{

			query = query + "&";

	        }
	
	       
                query = query + x[2*i] + "=" + x[2*i+1];

		

	}



	if(query != "")

	{

		url = "displayView.do?" + query ;

	}

	else

	{

		url = "displayView.do";

	}



	debug("new url: " + url);

	return url;

}

//start of gotoAddressbookPage

function gotoAddressbookPage(paramlist)

{

	x = new Array;

	countup = 0;



	debug("gotoAddressbookPage() called");



	// Finds old items in current URL which are only found in it

	// Array X holds the result items that will form the new URL



	args = getQueryArgs();









	//filterargs contains all the sort elements that is going to be apear in new URL

	  filterargs = PrepareFilterParams(arguments);



	  //sortargs contains all the sort elements that is going to be apear in new URL

	  sortargs = PrepareSortParams(arguments);



	  //selectargs contains all the select elements that is going to be apear in new URL

	  selectargs = PrepareSelectParams(arguments);







	for (i=0;i<args.length;i++)

	{



		nv =args[i].split("=");

		if((null == nv) || (2 != nv.length))

		{

			// invalid querystring arg - skip it

			debug("invalid querystring arg: " + args[i] + " - skipping");

			continue;

		}


	
		// handle Pattern override as needed

		if(("pattern" == nv[0]) && (bViewChange))

		{

			// suppress use of "current pattern"

			debug("gotoPage: discarding current pattern because view has changed");

			continue;

		}



		// handle RegexPattern override as needed

		if(("regexpattern" == nv[0]) && (bViewChange))

		{

			// suppress use of "current regexpattern"

			debug("gotoPage: discarding current regexpattern because view has changed");

			continue;

		}



		// handle Sort override as needed

		if(("sortParams"==nv[0]) && (bViewChange || bPatternChange || bRegexPatternChange ||bPageChange))

		{

			// suppress use of current sort parameters

			debug("gotoPage: discarding current sort parameters because something has changed");

			continue;

		}





		found = false;



		for(j=0;j<arguments.length;j++)

		{

			debug("checking: " + nv[0] + " vs. " + arguments[j][0]);

			if (nv[0] == arguments[j][0])

			{



				found =true;

				break;

			}

		}



		if(found == false)

		{

			if((nv[0] == "SortElement") || (nv[0] == "Filter") || (nv[0] == "Select"))

				{

					break;

				}



			x[countup++] = nv[0];

			x[countup++] = nv[1];

		}

	}







	// Array X now holds the items from the current URL

	// Now Populate the array X with the new items from value arrays



	for (k=0; k<arguments.length;k++)

	{



			debug("gotoPage arg " + k + ": " + arguments[k]);



			nname = arguments[k][0];

			nvals = arguments[k][1];

			if((nname == "SortElement") || (nname == "Filter") || (nname == "Select"))

				{

					continue;

				}

			if(nvals[0] != null)

			{

				for (m =0; m<nvals.length;m++)

				{



					x[countup++] = nname;

					x[countup++] = nvals[m];

				}

			}



	}



	//Add SortElements one by one to the array which is used to create the new url

	if(sortargs[1][0] != null)

	{

		for(z=0;z<sortargs[1].length;z++)

		{

			x[countup++] = "SortElement";

			x[countup++] =	sortargs[1][z];

		}



	}



	//Add Filter elements one by one to the array which is used to create the new url

	if(filterargs[1][0] != null)

	{

		for(z=0;z<filterargs[1].length;z++)

		{

			x[countup++] = "Filter";

			x[countup++] =	filterargs[1][z];

		}



	}





	//Add Select elements one by one to the array which is used to create the new url

	if(selectargs[1][0] != null)

	{

		for(z=0;z<selectargs[1].length;z++)

		{

			x[countup++] = "Select";

			x[countup++] =	selectargs[1][z];

		}



	}





	// reset defaults

	bViewChange = false;

	bPatternChange = false;

	bRegexPatternChange = false;

	bPageChange = false;

	bSortChanged = false;

	bFilterChanged = false;

	bSelectChanged = false;

	bResetPressed =false;



	// Process the array X and generate new URL

	query = "";

	for(i=0;i<x.length/2;i++)

	{

		if(query.length>0)

		{

			query = query + "&";

		}

		query = query + x[2*i] + "=" + x[2*i+1];

	}



	if(query != "")

	{

		url = "displayView.do?" + query ;

	}

	else

	{

		url = "displayView.do";

	}



	debug("new url: " + url);

	return url;

}



//end of gotoAddressbookPage




function Addbook(pnum)

{

	//bPageChange = true;

	if((null == pnum) || ("" == pnum))

	{

	pnum = "toggle";

	}



	// force conversion to string

	newpage = "" + pnum;

	debug("page: " + newpage);



	return new Array("addressbook",new Array(newpage));

}



// Format the subindex to be format (xxx)%20xxx-xxxx

function formatsubIndex(mtn)

{

	mtn = mtn.replace(/[^0-9]/g,"");

	var mtn1 = mtn.substring(0,3);

	var mtn2 = mtn.substring(3,6);

	var mtn3 = mtn.substring(6,10);

	mtn = "(" + mtn1 + ")%20" + mtn2 + "-" + mtn3;

	return mtn;

}

function getMTNTotalChgs(viewName)

{

    window.location="displayView.do?subViewName="+viewName+"&subViewType=HTML";

}    	



function getPrintFriendly()

{

    window.open("displayView.do?viewName=PrintFriendly&viewType=HTML");
   
}  